blob: a38b0cce91ffdac90ea274c1b8877aa76476c81c [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
Vincent Driessenddb350b2010-07-09 09:42:09 +02006# http://nvie.com/git-model
Benedikt Böhm00ccea62010-01-26 12:39:36 +01007#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
Vincent Driessend72acba2010-04-04 16:10:17 +020011# Copyright 2010 Vincent Driessen. All rights reserved.
12#
13# Redistribution and use in source and binary forms, with or without
14# modification, are permitted provided that the following conditions are met:
15#
16# 1. Redistributions of source code must retain the above copyright notice,
17# this list of conditions and the following disclaimer.
18#
19# 2. Redistributions in binary form must reproduce the above copyright
20# notice, this list of conditions and the following disclaimer in the
21# documentation and/or other materials provided with the distribution.
22#
23# THIS SOFTWARE IS PROVIDED BY VINCENT DRIESSEN ``AS IS'' AND ANY EXPRESS OR
24# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
25# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
26# EVENT SHALL VINCENT DRIESSEN OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
27# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
28# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
30# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
31# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
32# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33#
34# The views and conclusions contained in the software and documentation are
35# those of the authors and should not be interpreted as representing official
36# policies, either expressed or implied, of Vincent Driessen.
Benedikt Böhm00ccea62010-01-26 12:39:36 +010037#
38
Vincent Driessen7832d6e2010-02-21 21:31:03 +010039require_git_repo
40require_gitflow_initialized
Vincent Driessend72e4ac2010-02-16 21:33:51 +010041gitflow_load_settings
Vincent Driessenc1598bf2010-02-20 16:52:48 +010042PREFIX=$(git config --get gitflow.prefix.feature)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010043
Benedikt Böhm00ccea62010-01-26 12:39:36 +010044usage() {
Vincent Driessenb03cf962010-02-01 22:00:39 +010045 echo "usage: git flow feature [list] [-v]"
Vincent Driessen2b829ce2010-07-09 09:36:20 +020046 echo " git flow feature start [-F] <name> [<base>]"
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +020047 echo " git flow feature finish [-rFk] <name|nameprefix>"
Vincent Driessen186d2b52010-01-27 23:48:39 +010048 echo " git flow feature publish <name>"
49 echo " git flow feature track <name>"
Vincent Driessena2e41162010-02-24 01:37:07 +010050 echo " git flow feature diff [<name|nameprefix>]"
51 echo " git flow feature rebase [-i] [<name|nameprefix>]"
Vincent Driessend43ab842010-05-27 11:26:01 -070052 echo " git flow feature checkout [<name|nameprefix>]"
Vincent Driessenf68d4052010-07-09 12:34:18 +020053 echo " git flow feature pull <remote> [<name>]"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010054}
55
Vincent Driessen186d2b52010-01-27 23:48:39 +010056cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010057 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010058}
59
Vincent Driessenb866b012010-01-28 01:01:53 +010060cmd_list() {
Vincent Driessen44174922010-02-02 23:53:21 +010061 DEFINE_boolean verbose false 'verbose (more) output' v
Vincent Driessen1b819232010-02-01 15:51:43 +010062 parse_args "$@"
63
Vincent Driessenf46e2902010-02-15 23:01:52 +010064 local feature_branches
65 local current_branch
66 local short_names
Vincent Driessen7832d6e2010-02-21 21:31:03 +010067 feature_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010068 if [ -z "$feature_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010069 warn "No feature branches exist."
Randy Merrillb681b452010-06-26 13:14:15 +080070 warn ""
71 warn "You can start a new feature branch:"
72 warn ""
73 warn " git flow feature start <name> [<base>]"
Randy Merrill4de01f22010-06-26 13:19:06 +080074 warn ""
Vincent Driessen186d2b52010-01-27 23:48:39 +010075 exit 0
76 fi
Adam Gibbinscf3da5a2010-08-22 19:13:34 +010077 current_branch=$(git branch --no-color | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen27592dd2010-02-06 14:45:39 +010078 short_names=$(echo "$feature_branches" | sed "s ^$PREFIX g")
Vincent Driessenf2536f42010-02-01 15:57:48 +010079
Vincent Driessenaa6d0162010-02-01 19:43:46 +010080 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010081 local width=0
82 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010083 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010084 local len=${#branch}
Vincent Driessenaa6d0162010-02-01 19:43:46 +010085 width=$(max $width $len)
86 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010087 width=$(($width+3))
Vincent Driessen1adbc3e2010-01-30 16:28:20 +010088
Vincent Driessenf46e2902010-02-15 23:01:52 +010089 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010090 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010091 local fullname=$PREFIX$branch
92 local base=$(git merge-base "$fullname" "$DEVELOP_BRANCH")
93 local develop_sha=$(git rev-parse "$DEVELOP_BRANCH")
94 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010095 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessenaa6d0162010-02-01 19:43:46 +010096 printf "* "
97 else
98 printf " "
99 fi
Vincent Driessen44174922010-02-02 23:53:21 +0100100 if flag verbose; then
Vincent Driessen1adbc3e2010-01-30 16:28:20 +0100101 printf "%-${width}s" "$branch"
Vincent Driessenf2536f42010-02-01 15:57:48 +0100102 if [ "$branch_sha" = "$develop_sha" ]; then
103 printf "(no commits yet)"
104 elif [ "$base" = "$branch_sha" ]; then
105 printf "(is behind develop, may ff)"
106 elif [ "$base" = "$develop_sha" ]; then
107 printf "(based on latest develop)"
108 else
109 printf "(may be rebased)"
110 fi
Vincent Driessenaa6d0162010-02-01 19:43:46 +0100111 else
112 printf "%s" "$branch"
113 fi
114 echo
115 done
Vincent Driessen186d2b52010-01-27 23:48:39 +0100116}
117
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100118cmd_help() {
119 usage
120 exit 0
121}
122
Vincent Driessend0991262010-02-06 21:19:07 +0100123require_name_arg() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100124 if [ "$NAME" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100125 warn "Missing argument <name>"
Vincent Driessen1b819232010-02-01 15:51:43 +0100126 usage
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100127 exit 1
128 fi
129}
130
Vincent Driessend0991262010-02-06 21:19:07 +0100131expand_nameprefix_arg() {
132 require_name_arg
133
Vincent Driessenf46e2902010-02-15 23:01:52 +0100134 local expanded_name
135 local exitcode
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100136 expanded_name=$(gitflow_resolve_nameprefix "$NAME" "$PREFIX")
Vincent Driessend0991262010-02-06 21:19:07 +0100137 exitcode=$?
138 case $exitcode in
139 0) NAME=$expanded_name
140 BRANCH=$PREFIX$NAME
141 ;;
142 *) exit 1 ;;
143 esac
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100144}
145
Vincent Driessenf68d4052010-07-09 12:34:18 +0200146use_current_feature_branch_name() {
147 local current_branch=$(git_current_branch)
148 if startswith "$current_branch" "$PREFIX"; then
149 BRANCH=$current_branch
150 NAME=${BRANCH#$PREFIX}
151 else
152 warn "The current HEAD is no feature branch."
153 warn "Please specify a <name> argument."
154 exit 1
155 fi
156}
157
Vincent Driessend0991262010-02-06 21:19:07 +0100158expand_nameprefix_arg_or_current() {
Vincent Driessenc62633f2010-02-02 10:48:50 +0100159 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100160 expand_nameprefix_arg
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100161 require_branch "$PREFIX$NAME"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100162 else
Vincent Driessenf68d4052010-07-09 12:34:18 +0200163 use_current_feature_branch_name
Vincent Driessenc62633f2010-02-02 10:48:50 +0100164 fi
165}
166
Vincent Driessenf68d4052010-07-09 12:34:18 +0200167name_or_current() {
168 if [ -z "$NAME" ]; then
169 use_current_feature_branch_name
170 fi
171}
172
173parse_cmdline() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100174 # parse options
175 FLAGS "$@" || exit $?
176 eval set -- "${FLAGS_ARGV}"
Vincent Driessenf68d4052010-07-09 12:34:18 +0200177}
178
179parse_args() {
180 parse_cmdline "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100181
182 # read arguments into global variables
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200183 NAME=${!#}
Vincent Driessen11560922010-02-01 21:58:37 +0100184 BRANCH=$PREFIX$NAME
Vincent Driessenb866b012010-01-28 01:01:53 +0100185}
186
Vincent Driessenf68d4052010-07-09 12:34:18 +0200187parse_remote_name() {
188 parse_cmdline "$@"
189
190 # read arguments into global variables
191 REMOTE=$1
192 NAME=$2
193 BRANCH=$PREFIX$NAME
194}
195
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100196cmd_start() {
Vincent Driessen44174922010-02-02 23:53:21 +0100197 DEFINE_boolean fetch false 'fetch from origin before performing local operation' F
Vincent Driessenea608952010-01-29 16:56:29 +0100198 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100199 BASE=${2:-$DEVELOP_BRANCH}
Vincent Driessend0991262010-02-06 21:19:07 +0100200 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100201
202 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100203 require_branch_absent "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100204
205 # update the local repo with remote changes, if asked
Vincent Driessen44174922010-02-02 23:53:21 +0100206 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100207 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100208 fi
209
Vincent Driessenc118a852010-04-04 16:32:04 +0200210 # if the origin branch counterpart exists, assert that the local branch
211 # isn't behind it (to avoid unnecessary rebasing)
212 if git_branch_exists "$ORIGIN/$DEVELOP_BRANCH"; then
213 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
214 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100215
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100216 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100217 if ! git checkout -b "$BRANCH" "$BASE"; then
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100218 die "Could not create feature branch '$BRANCH'"
219 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100220
221 echo
222 echo "Summary of actions:"
223 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
224 echo "- You are now on branch '$BRANCH'"
225 echo ""
226 echo "Now, start committing on your feature. When done, use:"
227 echo ""
gmallard192ff522010-04-01 19:31:09 -0400228 echo " git flow feature finish $NAME"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100229 echo
230}
231
232cmd_finish() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100233 DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F
Vincent Driessen44174922010-02-02 23:53:21 +0100234 DEFINE_boolean rebase false 'rebase instead of merge' r
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200235 DEFINE_boolean keep false 'keep branch after performing finish' k
Vincent Driessen1b819232010-02-01 15:51:43 +0100236 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100237 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100238
239 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100240 require_branch "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100241
Vincent Driessen49c7d022010-01-28 12:40:33 +0100242 # detect if we're restoring from a merge conflict
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100243 if [ -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE" ]; then
Vincent Driessen49c7d022010-01-28 12:40:33 +0100244 #
245 # TODO: detect that we're working on the correct branch here!
246 # The user need not necessarily have given the same $NAME twice here
247 # (although he/she should).
248 #
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100249
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100250 # TODO: git_is_clean_working_tree() should provide an alternative
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100251 # exit code for "unmerged changes in working tree", which we should
252 # actually be testing for here
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100253 if git_is_clean_working_tree; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100254 FINISH_BASE=$(cat "$DOT_GIT_DIR/.gitflow/MERGE_BASE")
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100255
256 # Since the working tree is now clean, either the user did a
257 # succesfull merge manually, or the merge was cancelled.
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100258 # We detect this using git_is_branch_merged_into()
259 if git_is_branch_merged_into "$BRANCH" "$FINISH_BASE"; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100260 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100261 helper_finish_cleanup
262 exit 0
263 else
264 # If the user cancelled the merge and decided to wait until later,
265 # that's fine. But we have to acknowledge this by removing the
266 # MERGE_BASE file and continuing normal execution of the finish
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100267 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100268 fi
Vincent Driessen49c7d022010-01-28 12:40:33 +0100269 else
270 echo
271 echo "Merge conflicts not resolved yet, use:"
272 echo " git mergetool"
273 echo " git commit"
274 echo
275 echo "You can then complete the finish by running it again:"
276 echo " git flow feature finish $NAME"
277 echo
278 exit 1
279 fi
280 fi
281
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100282 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100283 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100284
Vincent Driessene034e4a2010-01-29 12:10:44 +0100285 # update local repo with remote changes first, if asked
Mark Derricutt8a86c482010-07-20 21:11:48 +1200286 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200287 if flag fetch; then
288 git fetch -q "$ORIGIN" "$BRANCH"
289 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100290 fi
291
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100292 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
293 require_branches_equal "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100294 fi
Mark Derricutt8a86c482010-07-20 21:11:48 +1200295 if has "$ORIGIN/$DEVELOP_BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200296 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
297 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100298
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100299 # if the user wants to rebase, do that first
Vincent Driessen44174922010-02-02 23:53:21 +0100300 if flag rebase; then
Vincent Driessen010252a2010-02-04 10:31:29 +0100301 if ! git flow feature rebase "$NAME" "$DEVELOP_BRANCH"; then
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100302 warn "Finish was aborted due to conflicts during rebase."
303 warn "Please finish the rebase manually now."
304 warn "When finished, re-run:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100305 warn " git flow feature finish '$NAME' '$DEVELOP_BRANCH'"
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100306 exit 1
307 fi
308 fi
309
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100310 # merge into BASE
Vincent Driessena4dd2232010-02-10 00:34:59 +0100311 git checkout "$DEVELOP_BRANCH"
312 if [ "$(git rev-list -n2 "$DEVELOP_BRANCH..$BRANCH" | wc -l)" -eq 1 ]; then
313 git merge --ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100314 else
Vincent Driessena4dd2232010-02-10 00:34:59 +0100315 git merge --no-ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100316 fi
317
Vincent Driessen49c7d022010-01-28 12:40:33 +0100318 if [ $? -ne 0 ]; then
319 # oops.. we have a merge conflict!
Vincent Driessen010252a2010-02-04 10:31:29 +0100320 # write the given $DEVELOP_BRANCH to a temporary file (we need it later)
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100321 mkdir -p "$DOT_GIT_DIR/.gitflow"
322 echo "$DEVELOP_BRANCH" > "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessen49c7d022010-01-28 12:40:33 +0100323 echo
324 echo "There were merge conflicts. To resolve the merge conflict manually, use:"
325 echo " git mergetool"
326 echo " git commit"
327 echo
328 echo "You can then complete the finish by running it again:"
329 echo " git flow feature finish $NAME"
330 echo
331 exit 1
332 fi
333
334 # when no merge conflict is detected, just clean up the feature branch
335 helper_finish_cleanup
336}
337
338helper_finish_cleanup() {
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100339 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100340 require_branch "$BRANCH"
341 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100342
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100343 # delete branch
Vincent Driessen44174922010-02-02 23:53:21 +0100344 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100345 git push "$ORIGIN" ":refs/heads/$BRANCH"
Vincent Driesseneec73c62010-02-02 16:14:16 +0100346 fi
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200347
348
349 if flag keep; then
350 echo "Keep this branch" > /dev/null
351 else
352 git branch -d "$BRANCH"
353 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100354
355 echo
356 echo "Summary of actions:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100357 echo "- The feature branch '$BRANCH' was merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100358 #echo "- Merge conflicts were resolved" # TODO: Add this line when it's supported
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200359 if flag keep; then
360 echo "- Feature branch '$BRANCH' has been kept"
361 else
362 echo "- Feature branch '$BRANCH' has been removed"
363 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100364 echo "- You are now on branch '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100365 echo
366}
367
368cmd_publish() {
Vincent Driessenea608952010-01-29 16:56:29 +0100369 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100370 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100371
372 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100373 require_clean_working_tree
374 require_branch "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100375 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100376 require_branch_absent "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100377
378 # create remote branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100379 git push "$ORIGIN" "$BRANCH:refs/heads/$BRANCH"
380 git fetch -q "$ORIGIN"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100381
382 # configure remote tracking
Vincent Driessena4dd2232010-02-10 00:34:59 +0100383 git config "branch.$BRANCH.remote" "$ORIGIN"
384 git config "branch.$BRANCH.merge" "refs/heads/$BRANCH"
385 git checkout "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100386
387 echo
388 echo "Summary of actions:"
389 echo "- A new remote branch '$BRANCH' was created"
390 echo "- The local branch '$BRANCH' was configured to track the remote branch"
391 echo "- You are now on branch '$BRANCH'"
392 echo
393}
394
395cmd_track() {
Vincent Driessenea608952010-01-29 16:56:29 +0100396 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100397 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100398
399 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100400 require_clean_working_tree
401 require_branch_absent "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100402 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100403 require_branch "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100404
405 # create tracking branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100406 git checkout -b "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100407
408 echo
409 echo "Summary of actions:"
410 echo "- A new remote tracking branch '$BRANCH' was created"
411 echo "- You are now on branch '$BRANCH'"
412 echo
413}
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100414
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100415cmd_diff() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100416 parse_args "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100417
Vincent Driessen5474e462010-02-04 15:50:06 +0100418 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100419 expand_nameprefix_arg
Vincent Driessena4dd2232010-02-10 00:34:59 +0100420 BASE=$(git merge-base "$DEVELOP_BRANCH" "$BRANCH")
421 git diff "$BASE..$BRANCH"
Vincent Driessen5474e462010-02-04 15:50:06 +0100422 else
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100423 if ! git_current_branch | grep -q "^$PREFIX"; then
Vincent Driessen5474e462010-02-04 15:50:06 +0100424 die "Not on a feature branch. Name one explicitly."
425 fi
426
Vincent Driessena4dd2232010-02-10 00:34:59 +0100427 BASE=$(git merge-base "$DEVELOP_BRANCH" HEAD)
428 git diff "$BASE"
Vincent Driessen5474e462010-02-04 15:50:06 +0100429 fi
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100430}
Vincent Driessenc62633f2010-02-02 10:48:50 +0100431
Vincent Driessend43ab842010-05-27 11:26:01 -0700432cmd_checkout() {
433 parse_args "$@"
434
435 if [ "$NAME" != "" ]; then
436 expand_nameprefix_arg
437 git checkout "$BRANCH"
438 else
439 die "Name a feature branch explicitly."
440 fi
441}
442
Vincent Driessena2baef92010-05-27 11:52:31 -0700443cmd_co() {
444 # Alias for checkout
445 cmd_checkout "$@"
446}
447
Vincent Driessenc62633f2010-02-02 10:48:50 +0100448cmd_rebase() {
Vincent Driessen44174922010-02-02 23:53:21 +0100449 DEFINE_boolean interactive false 'do an interactive rebase' i
Vincent Driessenc62633f2010-02-02 10:48:50 +0100450 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100451 expand_nameprefix_arg_or_current
Vincent Driessenc62633f2010-02-02 10:48:50 +0100452 warn "Will try to rebase '$NAME'..."
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100453 require_clean_working_tree
454 require_branch "$BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100455
456 git checkout -q "$BRANCH"
Vincent Driessenf46e2902010-02-15 23:01:52 +0100457 local OPTS=
Vincent Driessen44174922010-02-02 23:53:21 +0100458 if flag interactive; then
Vincent Driessenc62633f2010-02-02 10:48:50 +0100459 OPTS="$OPTS -i"
460 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100461 git rebase $OPTS "$DEVELOP_BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100462}
Vincent Driessenf68d4052010-07-09 12:34:18 +0200463
464avoid_accidental_cross_branch_action() {
465 local current_branch=$(git_current_branch)
466 if [ "$BRANCH" != "$current_branch" ]; then
467 warn "Trying to pull from '$BRANCH' while currently on branch '$current_branch'."
468 warn "To avoid unintended merges, git-flow aborted."
469 return 1
470 fi
471 return 0
472}
473
474cmd_pull() {
475 #DEFINE_string prefix false 'alternative remote feature branch name prefix' p
476 parse_remote_name "$@"
477
478 if [ -z "$REMOTE" ]; then
479 die "Name a remote explicitly."
480 fi
481 name_or_current
482
483 # To avoid accidentally merging different feature branches into each other,
484 # die if the current feature branch differs from the requested $NAME
485 # argument.
486 local current_branch=$(git_current_branch)
487 if startswith "$current_branch" "$PREFIX"; then
488 # we are on a local feature branch already, so $BRANCH must be equal to
489 # the current branch
490 avoid_accidental_cross_branch_action || die
491 fi
492
493 require_clean_working_tree
494
495 if git_branch_exists "$BRANCH"; then
496 # Again, avoid accidental merges
497 avoid_accidental_cross_branch_action || die
498
499 # we already have a local branch called like this, so simply pull the
500 # remote changes in
501 git pull -q "$REMOTE" "$BRANCH" || die "Failed to pull from remote '$REMOTE'."
502 echo "Pulled $REMOTE's changes into $BRANCH."
503 else
504 # setup the local branch clone for the first time
505 git fetch -q "$REMOTE" "$BRANCH" || die "Fetch failed." # stores in FETCH_HEAD
506 git branch --no-track "$BRANCH" FETCH_HEAD || die "Branch failed."
507 git checkout -q "$BRANCH" || die "Checking out new local branch failed."
508 echo "Created local branch $BRANCH based on $REMOTE's $BRANCH."
509 fi
510}